<?php

namespace Drupal\signageos\Commands;

use Drupal\Core\StringTranslation\StringTranslationTrait;
use \Drupal\digital_signage_framework\Commands\DeviceCommands as FrameworkDeviceCommands;
use Drupal\signageos\Plugin\Action\PowerAction;

/**
 * A Drush commandfile for signageOS devices.
 */
class DeviceCommands extends FrameworkDeviceCommands {

  use StringTranslationTrait;

  /**
   * Execute power action on signageOS device.
   *
   * @usage signageos:device:poweraction
   *   Executes power action on signagePS device.
   *
   * @command signageos:device:poweraction
   * @param int $deviceId
   * @param string|null $action
   * @aliases sosdpa
   */
  public function powerAction($deviceId, $action = NULL) {
    if ($device = $this->loadDevice($deviceId, 'signageos')) {
      if ($action === NULL) {
        $action = $this->io()->choice($this->t('Power action:'), PowerAction::powerActions());
      }
      $device->getPlugin()->sendPowerAction($device, $action);
    }
  }

}
