<?php

namespace Drupal\signageos\Form;

use Drupal\Core\Form\FormStateInterface;
use Drupal\digital_signage_framework\Form\ActionBase;

/**
 * Push power actions to devices.
 */
class PowerAction extends ActionBase {

  /**
   * {@inheritdoc}
   */
  protected function id() {
    return 'signageos_power_action';
  }

  /**
   * {@inheritdoc}
   */
  public function getQuestion() {
    return $this->t('Push power action to selected devices');
  }

  /**
   * {@inheritdoc}
   */
  public function getConfirmText() {
    return $this->t('Push');
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $form = parent::buildForm($form, $form_state);
    $form['action'] = [
      '#type' => 'select',
      '#title' => $this->t('Power action'),
      '#options' => \Drupal\signageos\Plugin\Action\PowerAction::powerActions(),
      '#required' => TRUE,
    ];

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    parent::submitForm($form, $form_state);
    if ($form_state->getValue('confirm')) {
      foreach ($this->devices as $device) {
        $device->getPlugin()->sendPowerAction($device, $form_state->getValue('action'));
      }
    }
  }

}
