<?php

namespace Drupal\signageos\Plugin\Action;

use Drupal\digital_signage_framework\Plugin\Action\Base;

/**
 * Execute power actions on devices.
 *
 * @Action(
 *   id = "signageos_power_action",
 *   label = @Translation("signageOS device Power Action"),
 *   type = "digital_signage_device",
 *   confirm_form_route_name = "signageos.poweraction"
 * )
 */
class PowerAction extends Base {

  public static function powerActions() {
    return [
      'APP_RESTART' => t('Restart'),
      'SYSTEM_REBOOT' => t('Reboot'),
      'APPLET_RELOAD' => t('Reload'),
      'APPLET_REFRESH' => t('Refresh'),
      'DISPLAY_POWER_ON' => t('Display power on'),
      'DISPLAY_POWER_OFF' => t('Display power off'),
      'APPLET_DISABLE' => t('Applet disable'),
      'APPLET_ENABLE' => t('Applet enable'),
    ];
  }

  protected function permission() {
    return 'execute signageos power action';
  }

}
